/* handle search form controls */
function processSearchForm(){
    var orderby = document.getElementById('orderInput');
    var ordertype = document.getElementById('orderTypeInput');
    var resultsperpage = document.getElementById('resultPerPageInput');
    var page = document.getElementById('pageInput');
    var maker = document.getElementById('makerInput');
    var body = document.getElementById('bodyInput');
    var query = document.getElementById('queryInput');
    
    // validate
    if( orderby == undefined || ordertype == undefined || resultsperpage == undefined || page == undefined ){
        console.log('There are undefined form data. Form not processed to avoid errors.');
        return false;
    }
    
    var ob = orderby.options[orderby.selectedIndex].value;
    var ot = ordertype.options[ordertype.selectedIndex].value;
    var rp = resultsperpage.options[resultsperpage.selectedIndex].value;
    var pg = page.options[page.selectedIndex].value;
    var result = '';
    
    // reset previously declared attr.
    if( maker != undefined && maker.value.length > 0 ){
        result += 'maker=' + maker.value + '&';
    }
    if( body != undefined && body.value.length > 0 ){
        result += 'body=' + body.value + '&';
    }
    if( query != undefined && query.value.length > 0 ){
        result += 'q=' + query.value + '&';
    }
    
    if( ob.length < 1 && ot.length < 1 && rp.length < 1 && pg.length < 1 ){
        // there are no values set to any of the filters.
        console.log('No filter has a value. Form not processed.');
        return false;
    }
    
    if( ob.length > 0 ){
        result += "o=" + ob + '&';
    }
    if( ot.length > 0 ){
        result += 'ot=' + ot + '&';
    }
    if( rp.length > 0 ){
        result += 'r=' + rp + '&';
    }
    if( pg.length > 0 ){
        result += 'pg=' + pg + '&';
    }
    
    result = result.substring(0, result.length - 1);
    
    // send data to page.
    window.location = '?' + result;
    
    return false;
}

/* display thumb as main image */
function displayMainImage(main,url,anchor){
    var main = document.getElementById(main);
    var anchor = document.getElementById(anchor);
    
    if( main != undefined ){
        main.src = url;
    }
    if( anchor != undefined ){
        anchor.href = url;
    }
}


